using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Google_Maps_Download
{
    public partial class LatLonToTiles : Form
    {
        public LatLonToTiles(string zoom)
        {
            InitializeComponent();

            Mzoom.Text = zoom;
        }

        private void Mzoom_TextChanged(object sender, EventArgs e)
        {
            CalculateXY();
        }

        private void poiLat_TextChanged(object sender, EventArgs e)
        {
            CalculateXY();
        }

        private void poiLon_TextChanged(object sender, EventArgs e)
        {
            CalculateXY();
        }

        private void CalculateXY()
        {
            try
            {
                #region borrowed code
                decimal lat = Decimal.Parse(poiLat.Text.Trim());
                decimal lon = Decimal.Parse(poiLon.Text.Trim());
                decimal zoom = Decimal.Parse(Mzoom.Text.Trim());

                //decimal PI = (decimal)3.14159265358979326433;
                decimal bc = (decimal)6.28318530717958652866;
                decimal Wa = (decimal)0.017453292519943295912944444444444;

                decimal c = 256;
                decimal d = 17;

                decimal pixelsPerLonDegree = 0;
                decimal pixelsPerLonRadian = 0;
                decimal bitmapOrigo = 0;

                while (d >= zoom)
                {
                    d = d - 1;
                    pixelsPerLonDegree = c / 360;
                    pixelsPerLonRadian = c / bc;
                    bitmapOrigo = c / 2;
                    //numTiles = c / 256;
                    c = c * 2;
                }

                decimal x = (bitmapOrigo + lon * pixelsPerLonDegree) / 256;
                decimal e = (decimal)Math.Sin(System.Convert.ToDouble(lat * Wa));
                decimal y = (bitmapOrigo + (decimal)0.5 * (decimal)Math.Log(System.Convert.ToDouble((1 + (e)) / (1 - (e)))) * -1 * pixelsPerLonRadian) / 256;
                #endregion

                Mx.Text = x.ToString("0");
                My.Text = y.ToString("0");
            }
            catch
            {
                Mx.Text = "";
                My.Text = "";
            }
        }

        private void btnAccept_Click(object sender, EventArgs e)
        {
            Mzoom.Text = Mzoom.Text.Trim();
            this.Close();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            Mzoom.Text = "";
            Mx.Text = "";
            My.Text = "";
            this.Close();
        }
    }
}